Hex Artifact Content

Artifact 7e37283f7c7d0b4511ea99dfa5c2cf35c7ae6860:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 43 4c 56 46 53 56 45 52 53 3d 22 32 30 30 38 30  CLVFSVERS="20080
0100: 35 30 33 22 0a 53 52 43 3d 22 73 72 63 2f 74 63  503".SRC="src/tc
0110: 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52  lvfs-${TCLVFSVER
0120: 53 7d 2e 74 61 72 2e 67 7a 22 0a 53 52 43 55 52  S}.tar.gz".SRCUR
0130: 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65  L="http://source
0140: 66 6f 72 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63  forge.net/projec
0150: 74 73 2f 74 63 6c 76 66 73 2f 66 69 6c 65 73 2f  ts/tclvfs/files/
0160: 74 63 6c 76 66 73 2f 74 63 6c 76 66 73 2d 24 7b  tclvfs/tclvfs-${
0170: 54 43 4c 56 46 53 56 45 52 53 7d 2f 74 63 6c 76  TCLVFSVERS}/tclv
0180: 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52 53 7d  fs-${TCLVFSVERS}
0190: 2e 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64  .tar.gz/download
01a0: 22 0a 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77  ".BUILDDIR="$(pw
01b0: 64 29 2f 62 75 69 6c 64 2f 74 63 6c 76 66 73 2d  d)/build/tclvfs-
01c0: 24 7b 54 43 4c 56 46 53 56 45 52 53 7d 22 0a 4f  ${TCLVFSVERS}".O
01d0: 55 54 44 49 52 3d 22 24 28 70 77 64 29 2f 6f 75  UTDIR="$(pwd)/ou
01e0: 74 22 0a 49 4e 53 54 44 49 52 3d 22 24 28 70 77  t".INSTDIR="$(pw
01f0: 64 29 2f 69 6e 73 74 22 0a 50 41 54 43 48 44 49  d)/inst".PATCHDI
0200: 52 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65  R="$(pwd)/patche
0210: 73 22 0a 65 78 70 6f 72 74 20 54 43 4c 56 46 53  s".export TCLVFS
0220: 56 45 52 53 20 53 52 43 20 53 52 43 55 52 4c 20  VERS SRC SRCURL 
0230: 42 55 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20  BUILDDIR OUTDIR 
0240: 49 4e 53 54 44 49 52 20 50 41 54 43 48 44 49 52  INSTDIR PATCHDIR
0250: 0a 0a 23 20 53 65 74 20 63 6f 6e 66 69 67 75 72  ..# Set configur
0260: 65 20 6f 70 74 69 6f 6e 73 20 66 6f 72 20 74 68  e options for th
0270: 69 73 20 73 75 62 2d 70 72 6f 6a 65 63 74 0a 4c  is sub-project.L
0280: 44 46 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47  DFLAGS="${LDFLAG
0290: 53 7d 20 24 7b 4b 43 5f 54 43 4c 56 46 53 5f 4c  S} ${KC_TCLVFS_L
02a0: 44 46 4c 41 47 53 7d 22 0a 43 46 4c 41 47 53 3d  DFLAGS}".CFLAGS=
02b0: 22 24 7b 43 46 4c 41 47 53 7d 20 24 7b 4b 43 5f  "${CFLAGS} ${KC_
02c0: 54 43 4c 56 46 53 5f 43 46 4c 41 47 53 7d 22 0a  TCLVFS_CFLAGS}".
02d0: 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50 50 46  CPPFLAGS="${CPPF
02e0: 4c 41 47 53 7d 20 24 7b 4b 43 5f 54 43 4c 56 46  LAGS} ${KC_TCLVF
02f0: 53 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49 42  S_CPPFLAGS}".LIB
0300: 53 3d 22 24 7b 4c 49 42 53 7d 20 24 7b 4b 43 5f  S="${LIBS} ${KC_
0310: 54 43 4c 56 46 53 5f 4c 49 42 53 7d 22 0a 65 78  TCLVFS_LIBS}".ex
0320: 70 6f 72 74 20 4c 44 46 4c 41 47 53 20 43 46 4c  port LDFLAGS CFL
0330: 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c 49 42  AGS CPPFLAGS LIB
0340: 53 0a 0a 72 6d 20 2d 72 66 20 27 62 75 69 6c 64  S..rm -rf 'build
0350: 27 20 27 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d  ' 'out' 'inst'.m
0360: 6b 64 69 72 20 27 62 75 69 6c 64 27 20 27 6f 75  kdir 'build' 'ou
0370: 74 27 20 27 69 6e 73 74 27 20 7c 7c 20 65 78 69  t' 'inst' || exi
0380: 74 20 31 0a 0a 54 43 4c 5f 56 45 52 53 49 4f 4e  t 1..TCL_VERSION
0390: 3d 22 75 6e 6b 6e 6f 77 6e 22 0a 69 66 20 5b 20  ="unknown".if [ 
03a0: 2d 66 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  -f "${TCLCONFIGD
03b0: 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68  IR}/tclConfig.sh
03c0: 22 20 5d 3b 20 74 68 65 6e 0a 09 73 6f 75 72 63  " ]; then..sourc
03d0: 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  e "${TCLCONFIGDI
03e0: 52 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22  R}/tclConfig.sh"
03f0: 0a 66 69 0a 65 78 70 6f 72 74 20 54 43 4c 5f 56  .fi.export TCL_V
0400: 45 52 53 49 4f 4e 0a 0a 69 66 20 5b 20 21 20 2d  ERSION..if [ ! -
0410: 66 20 22 24 7b 53 52 43 7d 22 20 5d 3b 20 74 68  f "${SRC}" ]; th
0420: 65 6e 0a 09 6d 6b 64 69 72 20 27 73 72 63 27 20  en..mkdir 'src' 
0430: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0440: 76 2f 6e 75 6c 6c 0a 0a 09 69 66 20 5b 20 21 20  v/null...if [ ! 
0450: 2d 64 20 27 62 75 69 6c 64 73 72 63 27 20 5d 3b  -d 'buildsrc' ];
0460: 20 74 68 65 6e 0a 09 09 72 6d 20 2d 66 20 22 24   then...rm -f "$
0470: 7b 53 52 43 7d 2e 74 6d 70 22 0a 09 09 77 67 65  {SRC}.tmp"...wge
0480: 74 20 2d 4f 20 22 24 7b 53 52 43 7d 2e 74 6d 70  t -O "${SRC}.tmp
0490: 22 20 22 24 7b 53 52 43 55 52 4c 7d 22 20 7c 7c  " "${SRCURL}" ||
04a0: 20 65 78 69 74 20 31 0a 09 09 6d 76 20 22 24 7b   exit 1...mv "${
04b0: 53 52 43 7d 2e 74 6d 70 22 20 22 24 7b 53 52 43  SRC}.tmp" "${SRC
04c0: 7d 22 0a 09 66 69 0a 66 69 0a 0a 28 0a 09 63 64  }"..fi.fi..(..cd
04d0: 20 27 62 75 69 6c 64 27 20 7c 7c 20 65 78 69 74   'build' || exit
04e0: 20 31 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 27   1...if [ ! -d '
04f0: 2e 2e 2f 62 75 69 6c 64 73 72 63 27 20 5d 3b 20  ../buildsrc' ]; 
0500: 74 68 65 6e 0a 09 09 67 7a 69 70 20 2d 64 63 20  then...gzip -dc 
0510: 22 2e 2e 2f 24 7b 53 52 43 7d 22 20 7c 20 74 61  "../${SRC}" | ta
0520: 72 20 2d 78 66 20 2d 0a 09 65 6c 73 65 20 20 20  r -xf -..else   
0530: 20 0a 09 09 63 70 20 2d 72 70 20 2e 2e 2f 62 75   ...cp -rp ../bu
0540: 69 6c 64 73 72 63 2f 2a 20 27 2e 2f 27 0a 09 66  ildsrc/* './'..f
0550: 69 0a 0a 09 63 64 20 22 24 7b 42 55 49 4c 44 44  i...cd "${BUILDD
0560: 49 52 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  IR}" || exit 1..
0570: 20 20 20 20 20 20 20 20 23 20 41 70 70 6c 79 20          # Apply 
0580: 72 65 71 75 69 72 65 64 20 70 61 74 63 68 65 73  required patches
0590: 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22  ..for patch in "
05a0: 24 7b 50 41 54 43 48 44 49 52 7d 2f 61 6c 6c 22  ${PATCHDIR}/all"
05b0: 2f 74 63 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53  /tclvfs-${TCLVFS
05c0: 56 45 52 53 7d 2d 2a 2e 64 69 66 66 20 22 24 7b  VERS}-*.diff "${
05d0: 50 41 54 43 48 44 49 52 7d 2f 24 7b 54 43 4c 5f  PATCHDIR}/${TCL_
05e0: 56 45 52 53 49 4f 4e 7d 22 2f 74 63 6c 76 66 73  VERSION}"/tclvfs
05f0: 2d 24 7b 54 43 4c 56 46 53 56 45 52 53 7d 2d 2a  -${TCLVFSVERS}-*
0600: 2e 64 69 66 66 3b 20 64 6f 0a 09 09 69 66 20 5b  .diff; do...if [
0610: 20 21 20 2d 66 20 22 24 7b 70 61 74 63 68 7d 22   ! -f "${patch}"
0620: 20 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74   ]; then....cont
0630: 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09 65 63 68  inue...fi....ech
0640: 6f 20 22 41 70 70 6c 79 69 6e 67 3a 20 24 7b 70  o "Applying: ${p
0650: 61 74 63 68 7d 22 0a 09 09 24 7b 50 41 54 43 48  atch}"...${PATCH
0660: 3a 2d 70 61 74 63 68 7d 20 2d 70 31 20 3c 20 22  :-patch} -p1 < "
0670: 24 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e 65 20  ${patch}"..done 
0680: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0690: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06a0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06b0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06c0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06d0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06e0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06f0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 0a 0a                ..
0700: 09 63 70 20 67 65 6e 65 72 69 63 2f 76 66 73 2e  .cp generic/vfs.
0710: 63 20 2e 0a 0a 09 23 20 49 66 20 77 65 20 61 72  c ....# If we ar
0720: 65 20 62 75 69 6c 64 69 6e 67 20 66 6f 72 20 57  e building for W
0730: 69 6e 33 32 2c 20 77 65 20 6e 65 65 64 20 74 6f  in32, we need to
0740: 20 64 65 66 69 6e 65 20 54 45 41 5f 50 4c 41 54   define TEA_PLAT
0750: 46 4f 52 4d 20 73 6f 20 74 68 61 74 0a 09 23 20  FORM so that..# 
0760: 74 68 65 20 72 69 67 68 74 20 70 72 69 76 61 74  the right privat
0770: 65 20 64 69 72 65 63 74 6f 72 79 20 69 73 20 66  e directory is f
0780: 6f 75 6e 64 0a 09 42 55 49 4c 44 54 59 50 45 3d  ound..BUILDTYPE=
0790: 22 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 54  "$(basename "${T
07a0: 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22 29 22 0a  CLCONFIGDIR}")".
07b0: 09 69 66 20 5b 20 22 24 7b 42 55 49 4c 44 54 59  .if [ "${BUILDTY
07c0: 50 45 7d 22 20 3d 20 22 77 69 6e 22 20 5d 3b 20  PE}" = "win" ]; 
07d0: 74 68 65 6e 0a 09 09 54 45 41 5f 50 4c 41 54 46  then...TEA_PLATF
07e0: 4f 52 4d 3d 22 77 69 6e 64 6f 77 73 22 0a 09 09  ORM="windows"...
07f0: 65 78 70 6f 72 74 20 54 45 41 5f 50 4c 41 54 46  export TEA_PLATF
0800: 4f 52 4d 0a 0a 09 09 43 46 4c 41 47 53 3d 22 24  ORM....CFLAGS="$
0810: 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 54 43 4c  {CFLAGS} -I${TCL
0820: 43 4f 4e 46 49 47 44 49 52 7d 22 0a 09 09 65 78  CONFIGDIR}"...ex
0830: 70 6f 72 74 20 43 46 4c 41 47 53 0a 09 66 69 0a  port CFLAGS..fi.
0840: 0a 09 23 20 49 66 20 77 65 20 61 72 65 20 62 75  ..# If we are bu
0850: 69 6c 64 69 6e 67 20 66 6f 72 20 4b 69 74 44 4c  ilding for KitDL
0860: 4c 2c 20 63 6f 6d 70 69 6c 65 20 77 69 74 68 20  L, compile with 
0870: 27 2d 66 50 49 43 27 0a 09 69 66 20 5b 20 22 24  '-fPIC'..if [ "$
0880: 7b 4b 49 54 54 41 52 47 45 54 7d 22 20 3d 20 22  {KITTARGET}" = "
0890: 6b 69 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a  kitdll" ]; then.
08a0: 09 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41  ..CFLAGS="${CFLA
08b0: 47 53 7d 20 2d 66 50 49 43 22 0a 09 09 65 78 70  GS} -fPIC"...exp
08c0: 6f 72 74 20 43 46 4c 41 47 53 0a 09 66 69 0a 0a  ort CFLAGS..fi..
08d0: 09 23 20 42 75 69 6c 64 20 73 74 61 74 69 63 20  .# Build static 
08e0: 76 65 72 73 69 6f 6e 0a 09 65 63 68 6f 20 22 52  version..echo "R
08f0: 75 6e 6e 69 6e 67 3a 20 2e 2f 63 6f 6e 66 69 67  unning: ./config
0900: 75 72 65 20 2d 2d 64 69 73 61 62 6c 65 2d 73 68  ure --disable-sh
0910: 61 72 65 64 20 2d 2d 70 72 65 66 69 78 3d 5c 22  ared --prefix=\"
0920: 24 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 65  ${INSTDIR}\" --e
0930: 78 65 63 2d 70 72 65 66 69 78 3d 5c 22 24 7b 49  xec-prefix=\"${I
0940: 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 6c 69 62 64  NSTDIR}\" --libd
0950: 69 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 2f  ir=\"${INSTDIR}/
0960: 6c 69 62 5c 22 20 2d 2d 77 69 74 68 2d 74 63 6c  lib\" --with-tcl
0970: 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  =\"${TCLCONFIGDI
0980: 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  R}\" ${CONFIGURE
0990: 45 58 54 52 41 7d 22 0a 09 2e 2f 63 6f 6e 66 69  EXTRA}".../confi
09a0: 67 75 72 65 20 2d 2d 64 69 73 61 62 6c 65 2d 73  gure --disable-s
09b0: 68 61 72 65 64 20 2d 2d 70 72 65 66 69 78 3d 22  hared --prefix="
09c0: 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d 65 78  ${INSTDIR}" --ex
09d0: 65 63 2d 70 72 65 66 69 78 3d 22 24 7b 49 4e 53  ec-prefix="${INS
09e0: 54 44 49 52 7d 22 20 2d 2d 6c 69 62 64 69 72 3d  TDIR}" --libdir=
09f0: 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22  "${INSTDIR}/lib"
0a00: 20 2d 2d 77 69 74 68 2d 74 63 6c 3d 22 24 7b 54   --with-tcl="${T
0a10: 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22 20 24 7b  CLCONFIGDIR}" ${
0a20: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 0a  CONFIGUREEXTRA}.
0a30: 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a  ..echo "Running:
0a40: 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 22 0a   ${MAKE:-make}".
0a50: 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 7c  .${MAKE:-make} |
0a60: 7c 20 65 78 69 74 20 31 0a 0a 09 65 63 68 6f 20  | exit 1...echo 
0a70: 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45  "Running: ${MAKE
0a80: 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 22  :-make} install"
0a90: 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20  ..${MAKE:-make} 
0aa0: 69 6e 73 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20  install || exit 
0ab0: 31 0a 0a 09 6d 6b 64 69 72 20 22 24 7b 4f 55 54  1...mkdir "${OUT
0ac0: 44 49 52 7d 2f 6c 69 62 22 20 7c 7c 20 65 78 69  DIR}/lib" || exi
0ad0: 74 20 31 0a 09 63 70 20 2d 72 20 22 24 7b 49 4e  t 1..cp -r "${IN
0ae0: 53 54 44 49 52 7d 2f 6c 69 62 22 2f 76 66 73 2a  STDIR}/lib"/vfs*
0af0: 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 2f   "${OUTDIR}/lib/
0b00: 22 0a 09 72 6d 20 2d 66 20 22 24 7b 4f 55 54 44  "..rm -f "${OUTD
0b10: 49 52 7d 2f 6c 69 62 22 2f 76 66 73 2a 2f 2a 2e  IR}/lib"/vfs*/*.
0b20: 61 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62  a "${OUTDIR}/lib
0b30: 22 2f 76 66 73 2a 2f 2a 2e 73 6f 0a 0a 09 65 78  "/vfs*/*.so...ex
0b40: 69 74 20 30 0a 29 20 7c 7c 20 65 78 69 74 20 31  it 0.) || exit 1
0b50: 0a 0a 65 78 69 74 20 30 0a                       ..exit 0.